<template>
  <div>
    <ValidationObserver v-slot="{ handleSubmit }">
      <form>
        <!-- Description -->
        <h3 class="line-header">
          <img
            src="@/assets/icons/company.svg"
            alt="Icone entreprise"
          /> Organisation
        </h3>
        <div class="form-row">
          <div class="form-group col-6">
            <label>Statut</label>
            <b-overlay :show="busy" rounded="lg" opacity="0.6">
              <template #overlay>
                <div class="d-flex align-items-center">
                  <b-spinner small type="grow" variant="secondary"></b-spinner>
                  <b-spinner type="grow" variant="dark"></b-spinner>
                  <b-spinner small type="grow" variant="secondary"></b-spinner>
                  <span class="sr-only">Please wait...</span>
                </div>
              </template>
              <Multiselect
                v-model="form.status"
                :options="statusOptions"
                track-by="choice"
                label="label"
                selectLabel=""
                selectedLabel=""
                deselectLabel=""
                :searchable="false"
                placeholder="Statut"
                @select="changeStatus"
              />
            </b-overlay>
          </div>
          <div class="form-group col-6">
            <label>{{ labelIdComp }}</label>
            <input
              v-model="form.idComp"
              class="form-control"
              type="text"
            >
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-10">
            <label class="required">Nom de l'organisation</label>
            <p>Inscrire le nom complet et en toutes lettres de l'organisation. Ex: Communauté des Communes Rurales de l'Entre-Deux-Mers</p>
            <ValidationProvider ref="display_name" rules="required" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.display_name"
                  class="form-control"
                  type="text"
                  placeholder="Nom de l'organisation"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-6">
            <label>Sigle</label>
            <ValidationProvider ref="acronym" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.acronym"
                  class="form-control"
                  type="text"
                  placeholder="Sigle"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-6">
            <label>Numéro de SIRET</label>
            <ValidationProvider ref="registration_number" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.registration_number"
                  class="form-control"
                  type="text"
                  placeholder="Numéro de SIRET"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-6">
            <label class="required">Type d'organisation</label>
            <ValidationProvider ref="organisation_type" rules="required" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <Multiselect
                  v-model="form.organisation_type"
                  :options="organisationsTypes"
                  track-by="codename"
                  label="display_name"
                  selectLabel=""
                  selectedLabel=""
                  deselectLabel=""
                  :searchable="false"
                  placeholder="Type d'organisation"
                />
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-6">
            <label>Logo de l'organisation</label>
            <p>Importer un logo au format JPG ou PNG (taille maximale: 2Mo)</p>
            <ValidationProvider ref="thumbnail" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <ImportImage
                  name="logo"
                  :title="organisation.thumbnail ? organisation.thumbnail.name : null"
                  :file="organisation.thumbnail ? organisation.thumbnail.url : null"
                  @update="setThumbnail"
                />
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-8">
            <label>Site web de l'organisation</label>
            <ValidationProvider ref="website_url" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.website_url"
                  class="form-control"
                  type="text"
                  placeholder="https://"
                  @focus="form.website_url === null ? form.website_url = 'https://' : null"
                  @blur="form.website_url === 'https://' ? form.website_url = null : null"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-12">
            <label>Description de l'organisation</label>
            <textarea
              v-model="form.description"
              class="form-control"
            />
          </div>
        </div>

        <!-- Coordonnées -->
        <h3 class="line-header">
          <img
            src="@/assets/icons/mail.svg"
            alt="Icône enveloppe"
          /> Coordonnées
        </h3>
        <div class="form-row">
          <div class="form-group col-6">
            <label>Téléphone de l'organisation</label>
            <ValidationProvider ref="phone_number" :rules="{ regex: /(?:(?:\+|00)33|0)\s*[1-9](?:[\s.-]*\d{2}){4}/}" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.phone_number"
                  class="form-control"
                  type="text"
                  placeholder="Téléphone de l'organisation"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-12">
            <label>Adresse postale</label>
            <ValidationProvider ref="postal_address" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <textarea
                  v-model="form.postal_address"
                  class="form-control"
                  type="text"
                  placeholder="Adresse postale"
                  rows="2"
                />
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>

        <!-- Territoire -->
        <h3 class="line-header">
          <img
            src="@/assets/icons/territory_map_cadastre.svg"
            alt="Icône carte cadastrale"
          /> Territoire
        </h3>
        <div class="form-row">
          <div class="form-check">
            <input
              v-model="territoireCheckbox"
              class="form-check-input-table"
              type="checkbox"
            >
            <label class="form-check-label">
              L'organisation n'est pas rattaché à un territoire
            </label>
          </div>
        </div>
        <div
          class="form-row"
          :class="{ disabled: territoireCheckbox }"
        >
          <div class="form-group col-8" style="margin-left: 1em;">
            <label>Territoire</label>
            <Multiselect
              v-model="form.jurisdiction"
              :options="organisationsJuridictions"
              track-by="id"
              label="display_name"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              :preserve-search="true"
              :show-no-results="false"
              placeholder="Sélectionner un territoire"
            />
          </div>
        </div>

        <!-- Convention -->
        <h3 class="line-header">
          <img
            src="@/assets/icons/official_document_convention.svg"
            alt="Icône document convention"
          /> Convention
        </h3>
        <div class="form-row">
          <div class="form-check">
            <input
              v-model="form.agreement_signed"
              class="form-check-input-table"
              type="checkbox"
            >
            <label class="form-check-label">
              L'organisation a signé une convention
            </label>
          </div>
        </div>
        <div
          class="form-row"
        >
          <div class="form-group col-8" style="margin-left: 2em;">
            <label>Convention</label>
            <ImportFile
              name="agreement"
              :type="'convention'"
              :title="organisation.agreement_file ? organisation.agreement_file.name : null"
              :fileName="organisation.agreement_file ? organisation.agreement_file.url : null"
              accept="application/*"
              @update="setAgreement"
            />
          </div>
        </div>
        <div class="form-footer">
          <b-button
            variant="outline-secondary"
            @click="$router.go(-1)"
          >
            Annuler
          </b-button>
          <b-button
            variant="primary"
            @click="handleSubmit(saveOrganisation)"
          >
            Enregistrer les modifications
          </b-button>
        </div>
      </form>
    </ValidationObserver>
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';

import ImportFile from '@/components/ImportFile.vue';
import ImportImage from '@/components/ImportImage.vue';
import Multiselect from 'vue-multiselect';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required, regex } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
extend('regex', {
  ...regex,
  message: 'Veuillez entrer un numéro de téléphone valide'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

const LABEL_ID_COMP = process.env.VUE_APP_LABEL_ID_COMP;

export default {
  name: 'OrganisationForm',

  components: {
    ImportFile,
    ImportImage,
    Multiselect,
    ValidationObserver,
    ValidationProvider
  },

  props: {
    organisation: {
      type: Object,
      default: () => { return {} }
    }
  },

  data() {
    return {
      busy: false,
      form: {
        status: {
          choice: null,
          label: null
        },
        idComp: null,
        display_name: null,
        acronym: null,
        registration_number: null,
        organisation_type: null,
        description: null,
        website_url: null,
        phone_number: null,
        postal_address: null,
        thumbnail: null,
        jurisdiction: null,
        agreement: null,
        agreement_signed: false
      },
      statusOptions: [
        {
          choice: 0,
          label: 'Attente de vérification'
        },
        {
          choice: 1,
          label: 'Attente de validation'
        },
        {
          choice: 2,
          label: 'Actif'
        }
      ],
      territoireCheckbox: true,
      labelIdComp: LABEL_ID_COMP
    }
  },

  computed: {
    ...mapState('organisations', [
      'currentOrganisation',
      'organisationsTypes',
      'organisationsError',
      'organisationsJuridictions'
    ]),
    ...mapState('usergroups', [
      'usergroupsList'
    ]),
    ...mapState('form', [
      'currentFormId',
      'currentForm'
    ])
  },

  watch: {
    form: {
      deep: true,
      handler(newValue) {
        this.SET_CURRENT_FORM({
          id: 'editOrganisation',
          form: newValue
        });
      }
    },
    organisationsError(newValue) {
      if (newValue) {
        for (const [key, value] of Object.entries(newValue)) {
          this.$refs[key].applyResult({
            errors: value,
            valid: false,
            failedRules: {}
          });
        }
      }
    }
  },

  created() {
    this.form.status.choice = this.organisation.usergroup.status;
    this.form.idComp = this.organisation.additional_id;
    this.form.status.label = this.statusOptions.find(el => el.choice === this.form.status.choice).label;
    this.form.display_name = this.organisation.display_name;
    this.form.acronym = this.organisation.acronym;
    this.form.website_url = this.organisation.website_url;
    this.form.phone_number = this.organisation.phone_number;
    this.form.registration_number = this.organisation.registration_number;
    this.form.description = this.organisation.description;
    this.form.organisation_type = this.organisation.organisation_type;
    this.form.postal_address = this.organisation.postal_address;
    this.form.jurisdiction = this.organisation.jurisdiction;
    if (this.form.jurisdiction) {
      this.territoireCheckbox = false;
    }
    if (this.organisation.agreement_signed) {
      this.form.agreement_signed = true;
    }
  },

  methods: {
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapActions('usergroups', [
      'PATCH_USERGROUP'
    ]),
    ...mapActions('organisations', [
      'GET_ORGANISATION_DETAIL',
    ]),

    setThumbnail(e) {
      const formData = new FormData();
      formData.append('file', e);
      this.form.thumbnail = formData;
    },

    setAgreement(e) {
      const formData = new FormData();
      formData.append('file', e);
      this.form.agreement = formData;
    },

    async changeStatus(e) {
      const data = { status: e.choice };
      this.busy = true;
      await this.PATCH_USERGROUP({ id: this.currentOrganisation.usergroup.id, data: data });
      await this.GET_ORGANISATION_DETAIL(this.currentOrganisation.id);
      this.busy = false;
    },

    saveOrganisation() {
      const data = {
        form: {
          codename: this.currentOrganisation.codename,
          ...this.form.idComp && { additional_id: this.form.idComp },
          ...this.form.display_name && { display_name: this.form.display_name },
          ...this.form.acronym && { acronym: this.form.acronym },
          ...this.form.registration_number && { registration_number: this.form.registration_number },
          ...this.form.description && { description: this.form.description },
          ...this.form.organisation_type && { organisation_type: this.form.organisation_type },
          ...this.form.website_url && { website_url: this.form.website_url },
          ...this.form.phone_number && { phone_number: this.form.phone_number },
          ...this.form.postal_address && { postal_address: this.form.postal_address },
          jurisdiction: this.territoireCheckbox ? null : this.form.jurisdiction,
          ...this.form.agreement_signed && { agreement_signed: this.form.agreement_signed }
        },
        ...this.form.thumbnail && { thumbnail: this.form.thumbnail },
        ...this.form.agreement && { agreement: this.form.agreement }
      }
      this.$emit('save', data);
    }
  }
}
</script>
